## net.sf.saxon.expr
Class ForExpression

    java.lang.Object
      |
      +--net.sf.saxon.expr.ComputedExpression
            |
            +--net.sf.saxon.expr.Assignation
                  |
                  +--net.sf.saxon.expr.ForExpression

All Implemented Interfaces:
  Binding, Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class ForExpression
extends Assignation

A ForExpression maps an expression over a sequence. This version works with range variables, it doesn't change the context information

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Assignation
`action, declaration, nameCode, sequence, slotNumber, variableName`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ForExpression()`

Method Summary
`Expression` `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`int` `computeCardinality()` Determine the static cardinality of the expression
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`protected int` `getConstructType()` Get the type of this expression for use in tracing and diagnostics
`ItemType` `getItemType()` Determine the data type of the items returned by the expression, if possible
`SequenceIterator` `iterate(XPathContext context)` Iterate over the sequence of values
`void` `process(XPathContext context)` Process this expression as an instruction, writing results to the current outputter
`void` `setAction(Expression action)` Add the "return" or "satisfies" expression, and fix up all references to the range variable that occur within that expression
`void` `setPositionVariable(RangeVariableDeclaration decl)` Set the reference to the position variable (XQuery only)

Methods inherited from class net.sf.saxon.expr.Assignation
`evaluateVariable, getVariableFingerprint, getVariableName, getVariableNameCode, iterateSubExpressions, promote, setSequence, setSlotNumber, setVariableDeclaration, simplify`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, computeDependencies, computeSpecialProperties, computeStaticProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ForExpression

    public ForExpression()

Method Detail

### setPositionVariable

    public void setPositionVariable(RangeVariableDeclaration decl)

  Set the reference to the position variable (XQuery only)

### setAction

    public void setAction(Expression action)

  Description copied from class: `Assignation`
  Add the "return" or "satisfies" expression, and fix up all references to the range variable that occur within that expression

  Overrides:
    `setAction` in class `Assignation`
  Parameters:
    `action` - the expression that occurs after the "return" keyword of a "for" expression, the "satisfies" keyword of "some/every", or the ":=" operator of a "let" expression.

    This method must be called after calling setVariableDeclaration()

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
    `XPathException`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate over the sequence of values

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### process

    public void process(XPathContext context)
                 throws XPathException

  Process this expression as an instruction, writing results to the current outputter

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `ComputedExpression`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
    `XPathException`

### getItemType

    public ItemType getItemType()

  Determine the data type of the items returned by the expression, if possible

  Returns:
    one of the values Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

### getConstructType

    protected int getConstructType()

  Get the type of this expression for use in tracing and diagnostics

  Overrides:
    `getConstructType` in class `ComputedExpression`
  Returns:
    the type of expression, as enumerated in class `Location`